from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class driverProvides(RelationBase):
    # Every unit connecting will get the same information
    scope = scopes.GLOBAL

    @hook('{provides:cinder-backend}-relation-{joined,changed}')
    def changed(self):
        conversation = self.conversation()
        conversation.set_state('{relation_name}.available')
        conversation.remove_state('{relation_name}.departing')

    @hook('{provides:cinder-backend}-relation-{broken,departed}')
    def broken(self):
        conversation = self.conversation()
        conversation.remove_state('{relation_name}.available')
        conversation.set_state('{relation_name}.departing')
