from charms.reactive import hook
from charms.reactive import RelationBase
from charms.reactive import scopes


class cinderRequires(RelationBase):
    scope = scopes.GLOBAL

    @hook('{requires:cinder-backend}-relation-joined')
    def joined(self):
        self.remove_state('{relation_name}.departing')
        self.set_state('{relation_name}.available')

    @hook('{requires:cinder-backend}-relation-changed')
    def changed(self):
        self.remove_state('{relation_name}.departing')
        self.set_state('{relation_name}.changing')

    @hook('{requires:cinder-backend}-relation-departed')
    def departed(self):
        self.remove_state('{relation_name}.available')
        self.remove_state('{relation_name}.changing')
        self.set_state('{relation_name}.departing')
